	LIST P=16f628

	__config 0x0142		;0x3f42 - memoria aberta
	__idlocs 0x0011		;ID locations q servem p indicar a versao

;*************************************************************
;       definioes
;*************************************************************

bank1   macro
	bsf     status, 5
	endm
bank0   macro
	bcf     status, 5
	endm

;**************************************************************************************

limpar_ram	macro
	movlw	0x20		;initialize pointer first page RAM
	movwf	fsr		;into RAM
next	clrf	indf		;clear indirect register
	incf	fsr, f		;inc pointer
	movlw	0x7f
	subwf	fsr, w
	btfss	status, z	;completed ??
	goto	next
	endm	

;**************************************************************************************

reset_a_0_dos_valores_wx	macro
	movlw	0x38			;posiciona ponteiro no inicio dos registos de WX
	movwf	fsr
	movlw	"."			;o ponto decimal "." indica dados inexistentes
	movwf	indf			;carrega o registo com W
	incf	fsr, f			;proxima posiao
	movlw	0x51
	subwf	fsr, w
	btfss	status, z		;completed ??
	goto	$-6
	endm	

;**************************************************************************************
	
indf    equ 	0x00
tmr0	equ	0x01
pcl     equ  	0x02
status	equ     0x03
fsr	equ  	0x04
porta   equ     0x05
portb   equ     0x06
pclath	equ	0x0a
intcon  equ     0x0b
pir1	equ	0x0c
pie1	equ	0x8c
options equ     0x81
trisa   equ     0x85
trisb   equ     0x86
txsta	equ	0x98
rcsta	equ	0x18
spbrg	equ	0x99
rcreg	equ	0x1a
t1con	equ	0x10
tmr1l	equ	0x0e
tmr1h	equ	0x0f	 
cmcon	equ	0x1f

w       equ	0
f       equ	1
c       equ	0                
dc      equ	1                
z       equ	2
e	equ	5
spen	equ	7
rcif	equ	5
rcie	equ	5
tmr1if	equ	0

;**************************************************************************************

#define	PTT_OUT		porta, 1
#define	MODEA_OUT	porta, 2
#define	MODEB_OUT	porta, 4
#define	TONE_OUT	porta, 3
#define	TX_DELAY	D'150'

#define	beacon_forcado	portb, 3
#define	RX_detect	porta, 5

;**************************************************************************************

	cblock  0x20

	w_temp, status_temp				;interrupt savings
	clkcnt, count, count3, count4, count5		;timers

	store1, loopa, loopb, loopc, index
	packet_sending_char, packet_sending_count
	packet_bit_history, packet_temp, packet_crc_hi, packet_crc_lo, temp2
	
	unidades, dezenas, _low, _high, flag_rs232
	
	direccao_cem, direccao_dez, direccao_um		;registos p valores de sensores, ja' tratados
	velocidade_cem, velocidade_dez, velocidade_um
	pico_cem, pico_dez, pico_um
	temperatura_cem, temperatura_dez, temperatura_um
	chuva_cem, chuva_dez, chuva_um
	humidade_dez, humidade_um
	pressao_10k, pressao_1k, pressao_cem, pressao_dez, pressao_um

	bateria_vento, bateria_chuva, bateria_outdoor, bateria_indoor

	flag_erro	;bits -> vento=0, chuva=1, outdoor=2, indoor=3
	
	temp_vento_2, temp_vento_3, temp_vento_4, temp_vento_5, temp_vento_6 
	temp_chuva_2, temp_chuva_3
	temp_outdoor_2, temp_outdoor_3, temp_outdoor_4
	temp_indoor_2, temp_indoor_3, temp_indoor_6, temp_indoor_7

	multiplicando, multiplicador
	temp						;usado p a rotina de binario->bcd
	H_byte, L_byte, R0, R1, R2, H_temp, L_temp

	cntaprs1, cntaprs2				;contadores p o delay entre Beacons

	endc

;*************************************************************

