;*********************************************************************
;	interrupt routines
;*********************************************************************
interrupt_routine

	movwf   w_temp          ;save off current W register contents
	swapf	status,w        ;move status register into W register
	movwf	status_temp     ;save off contents of STATUS register
 
	btfsc	pir1, rcif	;usart interrupt ??
	 goto	_usart

	btfsc	pir1, tmr1if	;TMR1 overflow ??
	 goto	_tmr1		;nao


	goto	terminar	;falso alarme, mas mesmo assim, isto nao devia acontecer

;-------------------------------------------------------------------------------
_usart

	call	usart		;routines to rx the GPS data
	goto	terminar

;-------------------------------------------------------------------------------

_tmr1	clrf	rcsta			;disable USART, enquanto esta' dentro da interrupao TMR1
	
	bcf	pir1, tmr1if		;clear TMR1 overflow

	decfsz	cntaprs1, f		;this 2 counters give the desired delays
	 goto	terminar
	movlw	.28			;7-5mins   14-10mins   28-20mins		10MHz cristal
	movwf	cntaprs1

	decfsz	cntaprs2, f		;  "       "      "       "      "
	 goto	terminar
	movlw	.200			;200 helps to get 5mins
	movwf	cntaprs2

	call	ax25			;manda pacote
	bcf	pir1, tmr1if		;clear TMR1 overflow

;-------------------------------------------------------------------------------

terminar
	movlw	b'10010000'	
	movwf	rcsta			;enable USART (p evitar bloqueamento da mesma, qd o Buffer de RX esta' cheio)

	swapf	status_temp,w   	;retrieve copy of STATUS register
	movwf	status          	;restore pre-isr STATUS register 
	swapf   w_temp,f
	swapf   w_temp,w        	;restore pre-isr W register contents

	retfie
