s;**********************************************************************************************
;	multiplicador 8x8
;**********************************************************************************************

mult    MACRO   bit             	; Begin macro
	btfsc   multiplicador, bit
	addwf   H_byte, 1
	rrf     H_byte, 1
	rrf     L_byte, 1
	ENDM                    	; End of macro

; *****************************         Begin Multiplier Routine
mul8x8	clrf    H_byte
	clrf    L_byte
	movf    multiplicando, W        ; move the multiplicand to W reg.
	bcf     status, c		; Clear the carry bit in the status Reg.
	mult    0
	mult    1
	mult    2
	mult    3
	mult    4
	mult    5
	mult    6
	mult    7
;
	retlw   0


;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************
;	binario p BCD
;**********************************************************************************************

B2_BCD  bcf     status, c		; clear the carry bit
	movlw   .16
	movwf   count
	clrf    R0
	clrf    R1
	clrf    R2
loop16  rlf     L_byte, F
	rlf     H_byte, F
	rlf     R2, F
	rlf     R1, F
	rlf     R0, F
;
	decfsz  count, F
	goto    adjDEC
	RETLW   0
;
adjDEC  movlw   R2
	movwf   fsr
	call    adjBCD
;
	movlw   R1
	movwf   fsr
	call    adjBCD
;
	movlw   R0
	movwf   fsr
	call    adjBCD
;
	goto    loop16
;
adjBCD  movlw   3
	addwf   0,W
	movwf   temp
	btfsc   temp,3          ; test if result > 7
	movwf   0
	movlw   30
	addwf   0,W
	movwf   temp
	btfsc   temp,7          ; test if result > 7
	movwf   0               ; save as MSD
	RETLW   0

;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************
;	BCD p binario
;**********************************************************************************************

mpy10b  andlw   0F
	addwf   L_byte, F
	btfsc   status, c
	incf    H_byte, F
mpy10a  bcf     status, c       ; multiply by 2
	rlf     L_byte,W
	movwf   L_temp
	rlf     H_byte,W        ; (H_temp,L_temp) = 2*N
	movwf   H_temp
;
	bcf     status, c       ; multiply by 2
	rlf     L_byte, F
	rlf     H_byte, F
	bcf     status, c       ; multiply by 2
	rlf     L_byte, F
	rlf     H_byte, F
	bcf     status, c       ; multiply by 2
	rlf     L_byte, F
	rlf     H_byte, F       ; (H_byte,L_byte) = 8*N
;
	movf    L_temp,W
	addwf   L_byte, F
	btfsc   status, c
	incf    H_byte, F
	movf    H_temp,W
	addwf   H_byte, F
	retlw   0               ; (H_byte,L_byte) = 10*N
;
;
BCDtoB  clrf    H_byte
	movf    R0,W
	andlw   0F
	movwf   L_byte
	call    mpy10a          ; result = 10a+b
;
	swapf   R1,W
	call    mpy10b          ; result = 10[10a+b]
;
	movf    R1,W
	call    mpy10b          ; result = 10[10[10a+b]+c]
;
	swapf   R2,W
	call    mpy10b          ; result = 10[10[10[10a+b]+c]+d]
;
	movf    R2,W
	andlw   0F
	addwf   L_byte, F
	btfsc   status, c
	incf    H_byte, F       ; result = 10[10[10[10a+b]+c]+d]+e
	retlw   0               ; BCD to binary conversion done

;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************
;**********************************************************************************************


